#!/usr/bin/python
import sys
import re

def main():
    """ 
    Parse the FOURCC values given by grep in FFmpeg
    
    The input file is the result of running:
        grep -re MKBETAG -e MKTAG *
    on the FFmpeg source directory.
    """
    if sys.argv.__len__()!=2 :
        print("SYNTAX: parse.py input.txt")
        return -1
    try:
        fin = open(sys.argv[1],'r')
    except IOError:
        print("Unable to open %s for read" % sys.argv[1])    
        return -1

    for line in fin:
        m = re.search('^[^:]+:', line)
        if m is not None:
            file_name = m.group(0)
        else:
            file_name = ''
        id = ""
        m = re.search('#define\s+\S*', line)
        if m is not None:
            m = re.split('\W+',m.group(0))
            id += m[2]+" "
        m = re.search('{\s*\S+\s*,\s*(MKBETAG|MKTAG)', line)
        if m is not None:
            m = re.split('\W+',m.group(0))
            id += m[1]+' '
        m = re.search('{\s*(MKBETAG|MKTAG)\([^)]*\),\s*\S+', line)
        if m is not None:
            m = re.split('\W+',m.group(0))
            id += m[len(m)-1]+' '
        m = re.search('/[*].+[*]/',line)
        if m is not None:
            id += m.group(0)+' '
        m = re.search('(MKBETAG|MKTAG)\([^)]*\)', line)
        if m is not None:
            print('{0:>30} {1:<30} {2}'.format(file_name, m.group(0), id))
            continue
        print line

    fin.close()


if __name__=='__main__':
    main()
   
